<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=ISO-8859-1" /><title>DefaultHttpParams xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/commons/httpclient/params/DefaultHttpParams.html">View Javadoc</a></div><pre>

<a name="1" href="#1">1</a>   <em class="comment">/*</em>
<a name="2" href="#2">2</a>   <em class="comment"> * $HeadURL: https://svn.apache.org/repos/asf/httpcomponents/oac.hc3x/trunk/src/java/org/apache/commons/httpclient/params/DefaultHttpParams.java $</em>
<a name="3" href="#3">3</a>   <em class="comment"> * $Revision$</em>
<a name="4" href="#4">4</a>   <em class="comment"> * $Date$</em>
<a name="5" href="#5">5</a>   <em class="comment"> *</em>
<a name="6" href="#6">6</a>   <em class="comment"> * ====================================================================</em>
<a name="7" href="#7">7</a>   <em class="comment"> *</em>
<a name="8" href="#8">8</a>   <em class="comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a name="9" href="#9">9</a>   <em class="comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a name="10" href="#10">10</a>  <em class="comment"> *  this work for additional information regarding copyright ownership.</em>
<a name="11" href="#11">11</a>  <em class="comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a name="12" href="#12">12</a>  <em class="comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a name="13" href="#13">13</a>  <em class="comment"> *  the License.  You may obtain a copy of the License at</em>
<a name="14" href="#14">14</a>  <em class="comment"> *</em>
<a name="15" href="#15">15</a>  <em class="comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a name="16" href="#16">16</a>  <em class="comment"> *</em>
<a name="17" href="#17">17</a>  <em class="comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a name="18" href="#18">18</a>  <em class="comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a name="19" href="#19">19</a>  <em class="comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a name="20" href="#20">20</a>  <em class="comment"> *  See the License for the specific language governing permissions and</em>
<a name="21" href="#21">21</a>  <em class="comment"> *  limitations under the License.</em>
<a name="22" href="#22">22</a>  <em class="comment"> * ====================================================================</em>
<a name="23" href="#23">23</a>  <em class="comment"> *</em>
<a name="24" href="#24">24</a>  <em class="comment"> * This software consists of voluntary contributions made by many</em>
<a name="25" href="#25">25</a>  <em class="comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a name="26" href="#26">26</a>  <em class="comment"> * information on the Apache Software Foundation, please see</em>
<a name="27" href="#27">27</a>  <em class="comment"> * &lt;<a href="http://www.apache.org/" target="alexandria_uri">http://www.apache.org/</a>>.</em>
<a name="28" href="#28">28</a>  <em class="comment"> *</em>
<a name="29" href="#29">29</a>  <em class="comment"> */</em>
<a name="30" href="#30">30</a>  
<a name="31" href="#31">31</a>  <strong>package</strong> <a href="../../../../../org/apache/commons/httpclient/params/package-summary.html">org.apache.commons.httpclient.params</a>;
<a name="32" href="#32">32</a>  
<a name="33" href="#33">33</a>  <strong>import</strong> java.io.Serializable;
<a name="34" href="#34">34</a>  <strong>import</strong> java.util.HashMap;
<a name="35" href="#35">35</a>  
<a name="36" href="#36">36</a>  <strong>import</strong> org.apache.commons.logging.Log;
<a name="37" href="#37">37</a>  <strong>import</strong> org.apache.commons.logging.LogFactory;
<a name="38" href="#38">38</a>  
<a name="39" href="#39">39</a>  <em>/**<em>*</em></em>
<a name="40" href="#40">40</a>  <em> * This class represents a collection of HTTP protocol parameters. Protocol parameters</em>
<a name="41" href="#41">41</a>  <em> * may be linked together to form a hierarchy. If a particular parameter value has not been</em>
<a name="42" href="#42">42</a>  <em> * explicitly defined in the collection itself, its value will be drawn from the parent </em>
<a name="43" href="#43">43</a>  <em> * collection of parameters.</em>
<a name="44" href="#44">44</a>  <em> * </em>
<a name="45" href="#45">45</a>  <em> * @author &lt;a href="<a href="mailto:oleg@ural.ru" target="alexandria_uri">mailto:oleg@ural.ru</a>">Oleg Kalnichevski&lt;/a></em>
<a name="46" href="#46">46</a>  <em> * </em>
<a name="47" href="#47">47</a>  <em> * @version $Revision$</em>
<a name="48" href="#48">48</a>  <em> * </em>
<a name="49" href="#49">49</a>  <em> * @since 3.0</em>
<a name="50" href="#50">50</a>  <em> */</em>
<a name="51" href="#51">51</a>  <strong>public</strong> <strong>class</strong> <a href="../../../../../org/apache/commons/httpclient/params/DefaultHttpParams.html">DefaultHttpParams</a> implements HttpParams, Serializable, Cloneable {
<a name="52" href="#52">52</a>  
<a name="53" href="#53">53</a>      <em>/**<em>* Log object for this class. */</em></em>
<a name="54" href="#54">54</a>      <strong>private</strong> <strong>static</strong> <strong>final</strong> Log LOG = LogFactory.getLog(DefaultHttpParams.<strong>class</strong>);
<a name="55" href="#55">55</a>  
<a name="56" href="#56">56</a>      <em>/**<em>* <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> class factory. */</em></em>
<a name="57" href="#57">57</a>      <strong>private</strong> <strong>static</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParamsFactory.html">HttpParamsFactory</a> httpParamsFactory = <strong>new</strong> <a href="../../../../../org/apache/commons/httpclient/params/DefaultHttpParamsFactory.html">DefaultHttpParamsFactory</a>();
<a name="58" href="#58">58</a>  
<a name="59" href="#59">59</a>      <em>/**<em>*</em></em>
<a name="60" href="#60">60</a>  <em>     * Gets the default HttpParams to be used.</em>
<a name="61" href="#61">61</a>  <em>     * </em>
<a name="62" href="#62">62</a>  <em>     * @return the value returned from &lt;code>HttpParamsFactory#getDefaultParams()&lt;/code></em>
<a name="63" href="#63">63</a>  <em>     * </em>
<a name="64" href="#64">64</a>  <em>     * @see HttpParamsFactory#getDefaultParams()</em>
<a name="65" href="#65">65</a>  <em>     */</em>
<a name="66" href="#66">66</a>      <strong>public</strong> <strong>static</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> getDefaultParams() {
<a name="67" href="#67">67</a>          <strong>return</strong> httpParamsFactory.getDefaultParams();
<a name="68" href="#68">68</a>      }
<a name="69" href="#69">69</a>      
<a name="70" href="#70">70</a>      <em>/**<em>*</em></em>
<a name="71" href="#71">71</a>  <em>     * Sets the factory that will provide the default HttpParams.</em>
<a name="72" href="#72">72</a>  <em>     * </em>
<a name="73" href="#73">73</a>  <em>     * @param httpParamsFactory an instance of HttpParamsFactory</em>
<a name="74" href="#74">74</a>  <em>     * </em>
<a name="75" href="#75">75</a>  <em>     * @see #getDefaultParams()</em>
<a name="76" href="#76">76</a>  <em>     */</em>
<a name="77" href="#77">77</a>      <strong>public</strong> <strong>static</strong> <strong>void</strong> setHttpParamsFactory(<a href="../../../../../org/apache/commons/httpclient/params/HttpParamsFactory.html">HttpParamsFactory</a> httpParamsFactory) {
<a name="78" href="#78">78</a>          <strong>if</strong> (httpParamsFactory == <strong>null</strong>) {
<a name="79" href="#79">79</a>              <strong>throw</strong> <strong>new</strong> IllegalArgumentException(<span class="string">"httpParamsFactory may not be null"</span>);
<a name="80" href="#80">80</a>          }
<a name="81" href="#81">81</a>          DefaultHttpParams.httpParamsFactory = httpParamsFactory;
<a name="82" href="#82">82</a>      }
<a name="83" href="#83">83</a>  
<a name="84" href="#84">84</a>      <em>/**<em>* The set of default values to defer to */</em></em>
<a name="85" href="#85">85</a>      <strong>private</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> defaults = <strong>null</strong>;
<a name="86" href="#86">86</a>  
<a name="87" href="#87">87</a>      <em>/**<em>* Hash map of HTTP parameters that this collection contains */</em></em>
<a name="88" href="#88">88</a>      <strong>private</strong> HashMap parameters = <strong>null</strong>;
<a name="89" href="#89">89</a>      
<a name="90" href="#90">90</a>      <em>/**<em>*</em></em>
<a name="91" href="#91">91</a>  <em>     * Creates a new collection of parameters with the given parent. </em>
<a name="92" href="#92">92</a>  <em>     * The collection will defer to its parent for a default value </em>
<a name="93" href="#93">93</a>  <em>     * if a particular parameter is not explicitly set in the collection</em>
<a name="94" href="#94">94</a>  <em>     * itself.</em>
<a name="95" href="#95">95</a>  <em>     * </em>
<a name="96" href="#96">96</a>  <em>     * @param defaults the parent collection to defer to, if a parameter</em>
<a name="97" href="#97">97</a>  <em>     * is not explictly set in the collection itself.</em>
<a name="98" href="#98">98</a>  <em>     */</em>
<a name="99" href="#99">99</a>      <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/params/DefaultHttpParams.html">DefaultHttpParams</a>(<strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> defaults) {
<a name="100" href="#100">100</a>         <strong>super</strong>();
<a name="101" href="#101">101</a>         <strong>this</strong>.defaults = defaults; 
<a name="102" href="#102">102</a>     }
<a name="103" href="#103">103</a>     
<a name="104" href="#104">104</a>     <em>/**<em>*</em></em>
<a name="105" href="#105">105</a> <em>     * Creates a new collection of parameters with the collection returned</em>
<a name="106" href="#106">106</a> <em>     * by {@link #getDefaultParams()} as a parent. The collection will defer</em>
<a name="107" href="#107">107</a> <em>     * to its parent for a default value if a particular parameter is not </em>
<a name="108" href="#108">108</a> <em>     * explicitly set in the collection itself.</em>
<a name="109" href="#109">109</a> <em>     * </em>
<a name="110" href="#110">110</a> <em>     * @see #getDefaultParams()</em>
<a name="111" href="#111">111</a> <em>     */</em>
<a name="112" href="#112">112</a>     <strong>public</strong> <a href="../../../../../org/apache/commons/httpclient/params/DefaultHttpParams.html">DefaultHttpParams</a>() {
<a name="113" href="#113">113</a>         <strong>this</strong>(getDefaultParams());
<a name="114" href="#114">114</a>     }
<a name="115" href="#115">115</a>     
<a name="116" href="#116">116</a>     <strong>public</strong> <strong>synchronized</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> getDefaults() {
<a name="117" href="#117">117</a>         <strong>return</strong> <strong>this</strong>.defaults;
<a name="118" href="#118">118</a>     }
<a name="119" href="#119">119</a>     
<a name="120" href="#120">120</a>     <strong>public</strong> <strong>synchronized</strong> <strong>void</strong> setDefaults(<strong>final</strong> <a href="../../../../../org/apache/commons/httpclient/params/HttpParams.html">HttpParams</a> params) {
<a name="121" href="#121">121</a>         <strong>this</strong>.defaults = params;
<a name="122" href="#122">122</a>     }
<a name="123" href="#123">123</a>     
<a name="124" href="#124">124</a>     <strong>public</strong> <strong>synchronized</strong> Object getParameter(<strong>final</strong> String name) {
<a name="125" href="#125">125</a>         <em class="comment">// See if the parameter has been explicitly defined</em>
<a name="126" href="#126">126</a>         Object param = <strong>null</strong>;
<a name="127" href="#127">127</a>         <strong>if</strong> (<strong>this</strong>.parameters != <strong>null</strong>) {
<a name="128" href="#128">128</a>             param = <strong>this</strong>.parameters.get(name);
<a name="129" href="#129">129</a>         }    
<a name="130" href="#130">130</a>         <strong>if</strong> (param != <strong>null</strong>) {
<a name="131" href="#131">131</a>             <em class="comment">// If so, return</em>
<a name="132" href="#132">132</a>             <strong>return</strong> param;
<a name="133" href="#133">133</a>         } <strong>else</strong> {
<a name="134" href="#134">134</a>             <em class="comment">// If not, see if defaults are available</em>
<a name="135" href="#135">135</a>             <strong>if</strong> (<strong>this</strong>.defaults != <strong>null</strong>) {
<a name="136" href="#136">136</a>                 <em class="comment">// Return default parameter value</em>
<a name="137" href="#137">137</a>                 <strong>return</strong> <strong>this</strong>.defaults.getParameter(name);
<a name="138" href="#138">138</a>             } <strong>else</strong> {
<a name="139" href="#139">139</a>                 <em class="comment">// Otherwise, return null</em>
<a name="140" href="#140">140</a>                 <strong>return</strong> <strong>null</strong>;
<a name="141" href="#141">141</a>             }
<a name="142" href="#142">142</a>         }
<a name="143" href="#143">143</a>     }
<a name="144" href="#144">144</a> 
<a name="145" href="#145">145</a>     <strong>public</strong> <strong>synchronized</strong> <strong>void</strong> setParameter(<strong>final</strong> String name, <strong>final</strong> Object value) {
<a name="146" href="#146">146</a>         <strong>if</strong> (<strong>this</strong>.parameters == <strong>null</strong>) {
<a name="147" href="#147">147</a>             <strong>this</strong>.parameters = <strong>new</strong> HashMap();
<a name="148" href="#148">148</a>         }
<a name="149" href="#149">149</a>         <strong>this</strong>.parameters.put(name, value);
<a name="150" href="#150">150</a>         <strong>if</strong> (LOG.isDebugEnabled()) {
<a name="151" href="#151">151</a>             LOG.debug(<span class="string">"Set parameter "</span> + name + <span class="string">" = "</span> + value);
<a name="152" href="#152">152</a>         }
<a name="153" href="#153">153</a>     }
<a name="154" href="#154">154</a>     
<a name="155" href="#155">155</a>     <em>/**<em>*</em></em>
<a name="156" href="#156">156</a> <em>     * Assigns the value to all the parameter with the given names</em>
<a name="157" href="#157">157</a> <em>     * </em>
<a name="158" href="#158">158</a> <em>     * @param names array of parameter name</em>
<a name="159" href="#159">159</a> <em>     * @param value parameter value</em>
<a name="160" href="#160">160</a> <em>     */</em> 
<a name="161" href="#161">161</a>     <strong>public</strong> <strong>synchronized</strong> <strong>void</strong> setParameters(<strong>final</strong> String[] names, <strong>final</strong> Object value) {
<a name="162" href="#162">162</a>         <strong>for</strong> (<strong>int</strong> i = 0; i &lt; names.length; i++) {
<a name="163" href="#163">163</a>             setParameter(names[i], value);
<a name="164" href="#164">164</a>         }
<a name="165" href="#165">165</a>     }
<a name="166" href="#166">166</a> 
<a name="167" href="#167">167</a>     <strong>public</strong> <strong>long</strong> getLongParameter(<strong>final</strong> String name, <strong>long</strong> defaultValue) { 
<a name="168" href="#168">168</a>         Object param = getParameter(name);
<a name="169" href="#169">169</a>         <strong>if</strong> (param == <strong>null</strong>) {
<a name="170" href="#170">170</a>             <strong>return</strong> defaultValue;
<a name="171" href="#171">171</a>         }
<a name="172" href="#172">172</a>         <strong>return</strong> ((Long)param).longValue();
<a name="173" href="#173">173</a>     }
<a name="174" href="#174">174</a>     
<a name="175" href="#175">175</a>     <strong>public</strong> <strong>void</strong> setLongParameter(<strong>final</strong> String name, <strong>long</strong> value) {
<a name="176" href="#176">176</a>         setParameter(name, <strong>new</strong> Long(value));
<a name="177" href="#177">177</a>     }
<a name="178" href="#178">178</a> 
<a name="179" href="#179">179</a>     <strong>public</strong> <strong>int</strong> getIntParameter(<strong>final</strong> String name, <strong>int</strong> defaultValue) { 
<a name="180" href="#180">180</a>         Object param = getParameter(name);
<a name="181" href="#181">181</a>         <strong>if</strong> (param == <strong>null</strong>) {
<a name="182" href="#182">182</a>             <strong>return</strong> defaultValue;
<a name="183" href="#183">183</a>         }
<a name="184" href="#184">184</a>         <strong>return</strong> ((Integer)param).intValue();
<a name="185" href="#185">185</a>     }
<a name="186" href="#186">186</a>     
<a name="187" href="#187">187</a>     <strong>public</strong> <strong>void</strong> setIntParameter(<strong>final</strong> String name, <strong>int</strong> value) {
<a name="188" href="#188">188</a>         setParameter(name, <strong>new</strong> Integer(value));
<a name="189" href="#189">189</a>     }
<a name="190" href="#190">190</a> 
<a name="191" href="#191">191</a>     <strong>public</strong> <strong>double</strong> getDoubleParameter(<strong>final</strong> String name, <strong>double</strong> defaultValue) { 
<a name="192" href="#192">192</a>         Object param = getParameter(name);
<a name="193" href="#193">193</a>         <strong>if</strong> (param == <strong>null</strong>) {
<a name="194" href="#194">194</a>             <strong>return</strong> defaultValue;
<a name="195" href="#195">195</a>         }
<a name="196" href="#196">196</a>         <strong>return</strong> ((Double)param).doubleValue();
<a name="197" href="#197">197</a>     }
<a name="198" href="#198">198</a>     
<a name="199" href="#199">199</a>     <strong>public</strong> <strong>void</strong> setDoubleParameter(<strong>final</strong> String name, <strong>double</strong> value) {
<a name="200" href="#200">200</a>         setParameter(name, <strong>new</strong> Double(value));
<a name="201" href="#201">201</a>     }
<a name="202" href="#202">202</a> 
<a name="203" href="#203">203</a>     <strong>public</strong> <strong>boolean</strong> getBooleanParameter(<strong>final</strong> String name, <strong>boolean</strong> defaultValue) { 
<a name="204" href="#204">204</a>         Object param = getParameter(name);
<a name="205" href="#205">205</a>         <strong>if</strong> (param == <strong>null</strong>) {
<a name="206" href="#206">206</a>             <strong>return</strong> defaultValue;
<a name="207" href="#207">207</a>         }
<a name="208" href="#208">208</a>         <strong>return</strong> ((Boolean)param).booleanValue();
<a name="209" href="#209">209</a>     }
<a name="210" href="#210">210</a>     
<a name="211" href="#211">211</a>     <strong>public</strong> <strong>void</strong> setBooleanParameter(<strong>final</strong> String name, <strong>boolean</strong> value) {
<a name="212" href="#212">212</a>         setParameter(name, value ? Boolean.TRUE : Boolean.FALSE);<em class="comment">// Boolean.valueOf() = Java 1.4+</em>
<a name="213" href="#213">213</a>     }
<a name="214" href="#214">214</a> 
<a name="215" href="#215">215</a>     <strong>public</strong> <strong>boolean</strong> isParameterSet(<strong>final</strong> String name) {
<a name="216" href="#216">216</a>         <strong>return</strong> getParameter(name) != <strong>null</strong>;
<a name="217" href="#217">217</a>     }
<a name="218" href="#218">218</a>         
<a name="219" href="#219">219</a>     <strong>public</strong> <strong>boolean</strong> isParameterSetLocally(<strong>final</strong> String name) {
<a name="220" href="#220">220</a>         <strong>return</strong> <strong>this</strong>.parameters != <strong>null</strong> &amp;&amp; <strong>this</strong>.parameters.get(name) != <strong>null</strong>;
<a name="221" href="#221">221</a>     }
<a name="222" href="#222">222</a>         
<a name="223" href="#223">223</a>     <strong>public</strong> <strong>boolean</strong> isParameterTrue(<strong>final</strong> String name) {
<a name="224" href="#224">224</a>         <strong>return</strong> getBooleanParameter(name, false);
<a name="225" href="#225">225</a>     }
<a name="226" href="#226">226</a>         
<a name="227" href="#227">227</a>     <strong>public</strong> <strong>boolean</strong> isParameterFalse(<strong>final</strong> String name) {
<a name="228" href="#228">228</a>         <strong>return</strong> !getBooleanParameter(name, false);
<a name="229" href="#229">229</a>     }
<a name="230" href="#230">230</a> 
<a name="231" href="#231">231</a>     <em>/**<em>*</em></em>
<a name="232" href="#232">232</a> <em>     * Removes all parameters from this collection. </em>
<a name="233" href="#233">233</a> <em>     */</em>
<a name="234" href="#234">234</a>     <strong>public</strong> <strong>void</strong> clear() {
<a name="235" href="#235">235</a>         <strong>this</strong>.parameters = <strong>null</strong>;
<a name="236" href="#236">236</a>     }
<a name="237" href="#237">237</a> 
<a name="238" href="#238">238</a>     <em>/**<em>*</em></em>
<a name="239" href="#239">239</a> <em>     * Clones this collection of parameters. Please note that paramter values</em>
<a name="240" href="#240">240</a> <em>     * themselves are not cloned. </em>
<a name="241" href="#241">241</a> <em>     * </em>
<a name="242" href="#242">242</a> <em>     * @see java.io.Serializable</em>
<a name="243" href="#243">243</a> <em>     * @see java.lang.Object#clone()</em>
<a name="244" href="#244">244</a> <em>     */</em>
<a name="245" href="#245">245</a>     <strong>public</strong> Object clone() throws CloneNotSupportedException
<a name="246" href="#246">246</a>     {
<a name="247" href="#247">247</a>         <a href="../../../../../org/apache/commons/httpclient/params/DefaultHttpParams.html">DefaultHttpParams</a> clone = (DefaultHttpParams)<strong>super</strong>.clone();
<a name="248" href="#248">248</a>         <strong>if</strong> (<strong>this</strong>.parameters != <strong>null</strong>) {
<a name="249" href="#249">249</a>             clone.parameters = (HashMap)<strong>this</strong>.parameters.clone(); 
<a name="250" href="#250">250</a>         }
<a name="251" href="#251">251</a>         clone.setDefaults(<strong>this</strong>.defaults);
<a name="252" href="#252">252</a>         <strong>return</strong> clone;
<a name="253" href="#253">253</a>     }
<a name="254" href="#254">254</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

